// keywords               48
// sysprocs               280
// sys variables          8
// sys defines            43
// sys functions          2
// directives             4     (setmaxbank,setmaxsprite,setmaxsam,setmaxmod)
// also string,int, float

//0=open
//1=close
//250,251 openin/out

#ifndef _xst2c_version
char *keywords[]={ "Print","If","EndIf","Rem","For","Next","Goto","Gosub","Return",
                   "Pop","Else","Do","Loop","End","Stop","OnErrorGoto",
                   "OnErrorGosub","OnErrorContinue","Input","Define",
                   "Include","Restore","Data","Read","Clear",
                   "OnBreakGoto","OnBreakGosub","Run","Dim",
                   "Repeat","Until","DefFn","Gobal","Procedure",
                   "EndProc","PopProc","PopFor","PopLoop","PopRepeat",
                   "Switch","EndSwitch","Case","EndCase","PopCase",
                   "DefaultCase","Polygon","Lprint","Polyline","Struct",
                   "GlobalStruct","Cadd", NULL};
#else
char *keywords[]={ "Print","If","EndIf","Rem","For","Next","Goto","Gosub","Return",
                   "Pop","Else","Do","Loop","End","Stop","OnErrorGoto",
                   "OnErrorGosub","OnErrorContinue","Input","Define",
                   "Include","Restore","Data","Read","Clear",
                   "OnBreakGoto","OnBreakGosub","Run","Dim",
                   "Repeat","Until","DefFn","Gobal","Procedure",
                   "EndProc","PopProc","PopFor","PopLoop","PopRepeat",
                   "Switch","EndSwitch","Case","EndCase","PopCase",
                   "DefaultCase","Polygon","Lprint","Polyline","Inc","Dec",
                   "Struct","GlobalStruct","Cadd",NULL};
#endif
//CLEAR clears variables, gosubsstack and forstack


//don't delete below lines, as it's a guide to returns and stuff
//char *sysprocs[]={ "OPEN","CLOSE",NULL};
//char *sysprocP[]={ "001","0", NULL };//0=INT, 1=STRING
//char sysprocR[]={ 9,9 };//0=retINT, 1=retSTRING, 9=NOret

typedef struct sys_var{ char *name; char type; }sys_var;
struct sys_var sysvariables[]={
                        {"Err_No",   0},//+0
                        {"Err_Ln",   0},//+1
                        {"MaxBank",  0},//+2
                        {"PcodeBase",0},//+3
                        {"Var_Base", 0},//+4
                        {"Param",    0},//+5
                        {"Param",    2},//+6 Param#
                        {"Param",    1},//+0 Param$
                        {NULL,     0} }; //"BasicBase"


typedef struct sys_deffn{ char *name; char *def; char *parm; }sys_deffn;
struct sys_deffn sysdeffns[]={
                            { "Inc",     "A=A+1", "A"},
                            { "Dec",     "A=A-1", "A"},
                            //{ "Read",    "DataRead __TMPVARIABLE : A=__TMPVARIABLE", "A"},
                            { NULL,NULL,NULL}
                            };


typedef struct sys_def{ char *name; char *def; }sys_def;
struct sys_def sysdefines[]={
                            { "On",     "1"},
                            { "Off",    "0"},
                            { "Flash",  "128"},//for flash (0x80)
                            { "Version","191"},
                            { "Mod",    "~"},
                            { "F_Read", "0"  },
                            { "F_Write","1"  },
                            { "F_Append","2" },
                            {  "r_AL",  "0"  },
                            {  "r_CL",  "1"  },
                            {  "r_DL",  "2"  },
                            {  "r_BL",  "3"  },
                            {  "r_AH",  "4"  },
                            {  "r_CH",  "5"  },
                            {  "r_DH",  "6"  },
                            {  "r_BH",  "7"  },
                            {  "r_AX",  "8"  },
                            {  "r_CX",  "9"  },
                            {  "r_DX",  "10" },
                            {  "r_BX",  "11" },
                            {  "r_SP",  "12" },
                            {  "r_BP",  "13" },
                            {  "r_SI",  "14" },
                            {  "r_DI",  "15" },
                            {  "r_EAX", "16" },
                            {  "r_ECX", "17" },
                            {  "r_EDX", "18" },
                            {  "r_EBX", "19" },
                            {  "r_ESP", "20" },
                            {  "r_EBP", "21" },
                            {  "r_ESI", "22" },
                            {  "r_EDI", "23" },
                            {  "r_ES",  "24" },
                            {  "r_CS",  "25" },
                            {  "r_SS",  "26" },
                            {  "r_DS",  "27" },
                            {  "r_FS",  "28" },
                            {  "r_GS",  "29" },
    //1.3
                            {  "Pi",    "3.141592" },
                            {  "Float", ""  },
                            {  "Int",   ""  },
   //1.6
                            {  "Global", "Gobal" },
                            {  "Pen",    "Ink" },
   //1.7
                            {  "A_Anim","0" },
                            {  "A_MoveWall","1" },
                            {  "A_MoveFloor","2" },
                            {  "A_ObjectTurn","3" },
                            {  "A_ObjectMove","4" },
                            {  "A_ObjectAnim","5" },
                            {  "A_ObjectSeek","6" },
                            {  "A_ObjectWatch","7" },
                            {  "A_Once","0" },
                            {  "A_Return","1" },
                            {  "A_Loop","2" },
                            {  "A_Repeat","3" },
  //1.8
                            {  "Svga","9+" },
#ifndef _xst2c_version
                            {  "Compiled","0" },
#else
                            {  "Compiled","1" },
#endif
//1.91
                            {  "XstWin","0" },
                            { NULL,NULL}
                            };

//add a "-" if TO is possible ,NEVER at the end
typedef struct sys_procs{ char *name; char *parmstr; char rettype; }sys_procs;
struct sys_procs sysprocs[]={
                  {"Open",     "001", 9},
                  {"Close",    "0",   9},
                  {"Randomize","0",   9},
                  {"Getc",     "10",  0},                  
                  {"Chr",      "0",   1},
                  {"Len",      "1",   0},
                  {"Hex",      "0",   1},
                  {"Oct",      "0",   1},
                  {"Str",      "0",   1},
                  {"Val",      "1",   0},
                  {"Abs",      "0",   0},
                  {"Sgn",      "0",   0},
                  {"Asc",      "1",   0},
                  {"Rnd",      "0",   0},
                  {"String",   "01",  1},
                  {"ToLower",  "1",   1},
                  {"ToUpper",  "1",   1},
                  {"Instr",    "011", 0},
                  {"Right",    "10",  1},
                  {"Left",     "10",  1},
                  {"Mid",      "100", 1},
                  {"SetReg",   "00",  9},
                  {"ReadReg",  "0",   0},
                  {"Int86",    "0",   9},
                  {"Lof",      "0",   0},
                  {"Loc",      "0",   0},
                  {"FreeFile", "",    0},
                  {"Exec",     "1",   0},//SPAWNthis also can run DOS commands
                  {"GetDir",   "",    1},
                  {"SetDir",   "1",   9},
                  {"MkDir",    "1",   9},
                  {"Get",      "0",   0},
                  {"Put",      "00",  9},
                  {"Eof",      "0",   0},
                  {"SetLoc",   "00",  9},
                  {"Free",     "",    0},
                  {"Dfree",    "",    0},
                  {"Rename",   "1-1", 9},
                  {"GetAttrib","1",   0},
                  {"SetAttrib","10",  9},
                  {"GetTime",  "0",   0},
                  {"GetDate",  "0",   0},
                  {"SetTime",  "00",  9},
                  {"SetDate",  "00",  9},
                  {"Date",     "",    1},
                  {"Time",     "",    1},
                  {"Beep",     "00",  9},
                  {"Wait",     "0",   9},
                  {"Kill",     "1",   9},
                  {"GetDrive"  ,"",   1},
                  {"SetDrive"  ,"1",  0},//returns total  drives avaiable
                  {"FindFirst","10",  1},
                  {"FindNext", "",    1},
                  {"Inkey",    "",    1},
                  {"ScanCode",  "",    0},
                  {"WaitKey",  "",    0},
                  {"Sleep",    "0",   9},//as delay but NO c-break checker
                  {"Varptr",   "1",   0},//parameter MUST be a Variable$
                  {"Peek",     "0",   0},
                  {"Deek",     "0",   0},//peekd
                  {"Leek",     "0",   0},//peekl
                  {"Poke",     "00",  9}, //byte
                  {"Doke",     "00",  9}, //db     poked
                  {"Loke",     "00",  9}, //long   pokel
                  {"Break",    "0",   9},//either on or off
                  {"KillDir",  "1",   9},//remove directory
                  {"Bin",      "0",   1},//only handles BYTE size'd
                  {"Erase",    "0",   9},//erase bank
                  {"EraseAll", "",    9},//eraseall
                  {"Bswap",    "00",  9},//bankswap
                  {"Reserve",  "00",  9},//reserve a bank
                  {"Bclear",   "0",   9},//clear bank
                  {"Bload",    "10",  9},//load to bank
                  {"Bsave",    "10",  9},//save from bank
                  {"Start",    "0",   0},//start of the memorybank
                  {"Length",   "0",   0},//length of bank
                  {"Bresize",  "00",  9},//resize the bank
                  {"Bank",     "0",   1},//returns the name of the bank
                  {"Brename",  "0-1",  9},//sets the name
                  {"Timer",    "",    0},//day*hr*sec*msec
//txtmode commands
                  {"Mode",    "0",    9},
                  {"Cls",     "+0+00-00",9},//clrscr(void);
                  {"Cline",   "",     9},//clreol(void);
                  {"DelLine", "",     9},//delline(void);
                  {"GetText", "000-00",9},//gettext(int _left, int _top, int _right, int _bottom, void *_destin);
                  {"Locate",  "00",   9},//gotoxy(int _x, int _y);NOTE:topleft is 1,1 not 0,0
                  {"InsLine", "",     9},//insline(void);
                  {"CopyText","0000-00",9},//movetext(int _left, int _top, int _right, int _bottom, int _destleft, int _desttop);
                  {"PutText", "000",9},//puttext(int _left, int _top, int _right, int _bottom, void *_source);        
                  {"Cursor",  "0",    9},//_setcursortype(int _type);
                  {"GetPaper","",     0},//textattr(int _attr);
                  {"GetInk",  "",     0},//textattr(int _attr);
                  {"Paper",   "0",    9},//textbackground(int _color);
                  {"Ink",     "0+0",    9},//textcolor(int _color);
                  {"CursX",   "",     0},//wherex(void);
                  {"CursY",   "",     0},//wherey(void);
                  {"Window",  "00-00", 9},//window(int _left, int _top, int _right, int _bottom);
                  {"GetChar", "00",   1},//returns the character on screen at x,y
                  {"GetWinRight","",  0},
                  {"GetWinBottom","", 0},
                  {"GetWinLeft","",   0},
                  {"GetWinTop","",    0},
                  {"GetScrX", "",     0},
                  {"GetScrY", "",     0},                  
//mouse commands
                  {"MouseAvail", "",    0},//returns 0 if no mouse there
                  {"MouseIn",   "00-00",0},//mouse in box (1yes, 0no)
                  {"MouseShow", "",    9},
                  {"MouseHide", "",    9},
                  {"MouseLocate","00", 9},
                  {"MouseX",    "",    0},
                  {"MouseY",    "",    0},
                  {"MouseKey",  "",    0},
                  {"WaitMouse", "",    0},
//command line params
                  {"GetMaxArg","",    0},
                  {"GetArg",   "0",   1},

                  {"Bjoin",     "00",  9},//not cmdline, more bank stuff
//gfx mode commands
                  {"EraseSprite", "",   9},
                  {"LoadSprite","1+0",  9},// "name",bank
                  {"SaveSprite","1",   9},//"name"     <-saves current bank
                  {"InsSprite", "0",   9},// where (There must be a sprite bank, use getsprite to make a bank)
                  {"DelSprite", "0",   9},// which
                  {"CopyFrontToBack","",  9},//  for double buffer
                  {"GetSpriteMaxX","0",   0},//returns lenX of sprite no
                  {"GetSpriteMaxY","0",   0},//returns lenY of sprite no
                  {"GetMaxSprite", "",    0},//returns how many sprites in bank
                  {"GetSpriteBase","0",   0},//returns offset in bank of sprite
                  {"DetectVGA",    "",    0},//returns if VGA card present
                  {"GetSprite",   "000-00",9},//grab me a sprite x,y,x2,y2,spriteno
                  {"PasteIcon",   "000",  9},//unmask'd sprite just
                  {"PasteSprite",      "000",  9},//masked version
                  {"DoubleBuffer", "+0",   9},
                  {"Update",       "",    9},
                  {"ScreenCopy",   "00000-000",9},
                  //{"SplitScreen",  "0",   9},
                  {"Shift",  "0",   9},
                  //{"SetScreenSize","00",  9},
                  {"ShiftDown",    "000", 9},
                  {"GetScreen",    "",    0},
                  {"ScreenSwap",   "",    9},
                  {"CopyBackToFront","",  9},//  for double buffer
                  {"PSet",         "00+0",  9},
                  {"PGet",         "00",  0},
                  //{"CopyOffScreen","0000-00",9},
                  //{"CopyOnScreen", "0000-00",9},
                  {"Box",          "00-00",9},
                  {"Bar",          "00-00",9},
                  {"GetPixel",     "00",  0},
                  {"Pixel",        "00+0",  9},
                  {"Fill",         "00",  9},
                  {"WaitVbl",      "",    9},
                  {"Line",         "00-00",9},
                  {"LoadFont",     "10",  9},//name$,bank
                  {"SetFont",      "0",   9},//bank
                  {"FadeOut",      "",    9},
                  {"FadeIn",       "",    9},
                  {"ShiftUp",      "000", 9},
                  {"SetColour",      "00",  9},//index,r,g,b
                  {"GetColour",    "0",   0},
                  {"SetPalette",   "0",   9},//bank
                  {"Rgb",          "000", 0},
                  {"PaletteBlack", "",    9},//so we can fade in
                  {"FindClosest",  "0",   0},
                  //{"BanksCopy",   "000000-0000", 9},//bankscopy no,startx,sty,xsiz,ysiz,xlen,desbank,startx,sty,bankxsiz
                  //{"BankBlit",    "000000-00",9},//bank,x1,y1,x2,y2,xlen,x1,y1
                  {"ReserveAsScreen","000",9},
                  {"ScreenMCopy","00000-000",9},//masked
                  {"MouseMoved",  "",     0},//returns 1 if the mouse has moved since last call
                  {"MouseVisible","",     0},//returns 1 if the mouse is visable
                  {"JoyX",        "0",    0},
                  {"JoyDetect",   "",     0},
                  {"FastKey",     "0",    9},
                  {"ScanKey",    "",     0},
//sfx commands
                  {"SetDefaultFreq",     "0",     9},   // sb_install_driver(int samplingRate);
                  {"SamStop",     "",     9},  //  sb_uninstall_driver();
                  {"SetDMA",     "0",     9},  //  sb_change_dma_channel(int newChannel);
                  {"GetDefaultFreq","",   0},  //  sb_sample_frequency;
                  {"SamDel",     "0",     9},//  sb_free_sample(sb_sample *sampleName);
                  {"SetFreq",    "00",    9},//sb_convert_frequency(sb_sample *source, int sourceFrequency,int destFrequency);
                  {"SamQueue",   "0",     9},//sb_queue_sample(sb_sample *sampleName);
                  {"SamPlay",    "0",     9},//sb_mix_sample(sb_sample *sampleName);
                  {"LoadSam",    "10",    9},//sb_load_sample(char *fileName, int fileType);
                  {"SamPlaying", "",      0},
                  {"SamVol",     "000",   9},//   a_sample->left_volume=a; (MAX=64 careful now)
                  {"LoadMod",    "10",    9},//sb_load_mod_file(char *modFileName);
                  {"ModPlay",    "0",     9},//sb_mod_play(sb_mod_file *modFile);
                  {"ModStop",    "",      9},// sb_mod_pause(void);
                  {"ModResume",  "",      9},// sb_mod_resume(void);
                  {"ModActive",  "",      0},// sb_mod_active;
                  {"ModDel",     "0",     9},// sb_free_mod_file(sb_mod_file *modToFree);
                  {"ModVol",     "0",     9},//sb_mod_volume (2 - 14 (Less is LOUDER)
//Samples,Mods are NOT stored in a bank!!!!
                  {"Screen",     "0",     9},//set current screen
                  //{"CopyToBank", "00000", 9},
                  {"SetMask",    "0",     9},
                  {"ScreenDCopy","00000-000",9},//no window limits
                  {"DimTop",     "10",    0},//parameter MUST be an array name
                  {"ClearKey",   "",      9},
                  {"Max",        "00",    0},
                  {"Min",        "00",    0},
                  //{"SerialStatus","0",    0},
                  //{"SerialSend",  "00",   0},
                  //{"SerialReceive","0",   0},
                  //{"SerialInit",   "00",  0},
//1.2
                  {"JLeft",       "0",    0},
                  {"JRight",      "0",    0},
                  {"JUp",         "0",    0},
                  {"JDown",       "0",    0},

                  {"Center",     "1",     9},
                  {"Cmove",      "00",    9},
                  {"DefaultPalette","",   9},
                  {"ReserveZone","0",     9},
                  {"SetZone",    "000-00",9},
                  {"MouseZone",  "",      0},
                  {"Zone",       "00",    0},
                  {"GetSpritePalette","", 9},
                  {"DCls",       "+0+00-00",9},//direct video clr
                  {"AutoUpdate", "0",     9},
                  {"LoadScreen", "1+0",    9},
                  {"SaveScreen", "1+0",    9},
                  {"GetPalette", "0+0",     9},
                  {"SpriteOn",   "0",     9},
                  {"SpriteOff",  "+0",     9},
                  {"Sprite",     "0000",  9},
                  {"SpriteCol",  "0",     0},
                  {"SpriteInCol","00",    0},
                  {"Priority",   "0",     9},
                  {"Hrev",       "0",     0},
                  {"Vrev",       "0",     0},
                  {"Rev",        "0",     0},
                  {"LoadBmp",    "1+0",    9},
                  {"SaveBmp",    "1+0",    9},
                  {"ScreenToFront","0",   9},//set current screen
                  {"GetScreenInFront","", 0},
                  {"LimitMouse", "00-00", 9},
                  {"JoyY",        "0",    0},
                  {"JoyFire",     "0",    0},
//1.3
                  {"UpDateEvery", "0",    9},
                  {"ScreenOffset","00",   9},
                  {"Sqrt",        "2",    2},//retfloat
                  {"Cos",         "2",    2},//retfloat
                  {"Tan",         "2",    2},//retfloat
                  {"Sin",         "2",    2},//retfloat
                  {"Log",         "2",    2},//retfloat
                  {"SetPercission","0",   9},
                  {"Sort",        "1",    9},//parameter MUST be an array name
                  {"FileExist",   "1",    0},
                 // {"GetResX",     "",     0},
                 // {"GetResY",     "",     0},
                  {"SetTypeRate", "00",   9},
                  {"KeyState",    "",     0},
                  {"GetBit",      "00",   0},
                  {"Rotate",      "00",   0},
                  {"Circle",      "000",  9},
                  {"Ellipse",     "0000", 9},
                  {"KeyPressed",  "0",    0},
                //these are now commands so they can tell if fastkey is on :)
                   { "Cup",       "",     0},//"328"
                   { "Cdown",     "",     0},//"336"
                   { "Cleft",     "",     0},//"331"
                   { "Cright",    "",     0},//"333"

                   {"MapBank",     "0",    9},
                   {"MapDraw",     "00",   9},
                   {"MapMove",     "00",   9},
                   {"GetMapX","",  0},
                   {"GetMapY","",  0},
//1.4
                  {"OpenIn",     "01",   9},
                  {"OpenOut",    "01",   9},
                  {"Win",        "0001", 0},
                  {"Fsel",       "0011", 1},
//1.5
                  {"GetSpriteX", "0",    0},
                  {"GetSpriteY", "0",    0},
                  {"BCopy",      "00",   9},
                  {"Shadow",     "0",    9},
                  {"ShadowColour","0",   9},
                  {"Bold",       "0",    9},
                  {"Underline",  "0",    9},
                  {"GetFileName","1",    1},
                  {"Italic",     "0",    9},
                  {"SetPrinter", "0",    9},
                  {"GetPrinterStatus","",0},
                  {"Text",       "001",  9},
                  {"Zoom",       "0000-0-000+00",9},
                  {"ZoomIn",     "000",  0},
                  {"ScreenHrev", "0",    9},
                  {"ScreenVrev", "0",    9},
                  {"ScreenRev",  "0",    9},
                  {"ScreenRemap","00",   9},
                  {"SpriteEdge", "0",    9},
                  {"SpriteTrim", "0",    9},
                  {"SetMouseSpeed","000",9},
                  {"SpriteRemap","0",    9},
                  {"LoadPcx",    "1+0",  9},
//1.6 (dir$)
                  {"GetKeyPressed","",  0},
                  {"ScanCodeToKeyPressed","0",  0},
                  {"Plot",       "00",  9},
                  {"Draw",       "00",  9},
//1.7
                  {"ScreenDualCopy", "000000-000",9},
                  {"OutPortByte","00", 9},
                  {"OutPortWord","00", 9},
                  {"OutPortLong","00", 9},
                  {"InPortByte", "0",  0},
                  {"InPortWord", "0",  0},
                  {"InPortLong", "0",  0},
        //3d commands :)
                  {"TdMove",     "00", 9},
                  {"TdTurn",     "00", 9},
                  {"TdSideStep", "00", 9},
                  {"TdMoveUp",   "00", 9},
                  {"TdSetFall",  "00", 9},
                  {"TdSetHeight","00", 9},
                  {"TdGetHeight","0",  0},
                  {"TdSetGravity","0", 9},
                  {"TdGetFloorHeight","0", 0},
                  {"TdGetCeilHeight","0",  0},
                  {"TdGetAreaType","0",  0},
//                  {"TdGetFloorTexture","0",  1},
//                  {"TdGetCeilTexture", "0",  0},
                  {"TdRemoveObjectAuto","0",  9},
                  {"TdHasObjectAuto","0", 0},

                  {"TdGetObjectX",     "0",  0},
                  //{"TdObject","0000001",  9},
                  {"TdObject","0000001+222",  9},
                  {"TdSetObject","0001",  9},

                  {"TdSetViewDir","00",  9},
                  {"TdGetViewDirX","",  0},
                  {"TdSetScreenSize","00-00",  9},

                  {"TdObjectVisible","0+000",  0},
                  {"TdLoadMap","1",  9},

                  {"TdSetShade","0",  9},
                  {"TdGetLight","",   0},
                  {"TdSetLight","0",  9},

                  {"TdClearCol","0", 9},
                  {"TdTestObjectCol","0",  0},
                  {"TdGetObjectCol","0",   0},

                  {"TdLoadTexture","11",      9},
                  {"TdEraseTexture","",  9},
                  {"TdSetTopTexture","01", 9},
                  {"TdSetWall","000-00+00",9},
                  {"TdGetWallX","0",  0},
                  {"TdGetTopTexture", "0",  1},
                  {"TdGetDistance","00",  0},
                  {"TdSetMinWallHeight","0",9},

                  {"TdRemoveWallAuto","0",  9},
                  {"TdSetAuto", "0000-0000",  9},
                  {"TdSetAnim","00",  9},
                  {"TdAnim","01+0",9},

                  {"TdSetPalette","0",   9},
                  {"TdMakePalette","000",  9},
                  {"TdMakeTable","00000", 9},
                  {"TdRender","",  9},
                  {"TdObjectOff","0",  9},
                  {"TdGetMaxShade","",  0},

                  {"TdSetFloorHeight","000",  9},
                  {"TdSetCeilHeight","000",  9},
                  {"TdSetBackFade","00", 9},
                  {"TdGetArea","0", 0},
                  {"TdHasWallAuto","0", 0},
                  {"TdGetPointX","0", 0},

                  {"TdGetPointY","0", 0},
                  {"TdGetObjectY","0",  0},
                  {"TdGetObjectZ","0",  0},
                  {"TdGetObjectAngle","0",0},
                  {"TdGetViewDirY","",  0},
                  {"TdClearWallCol","0", 9},
                  {"TdClearObjectCol","0", 9},
                  {"TdTestWallCol","0",  0},
                  {"TdGetWallCol","0",   0},
                  {"TdSetMidTexture","01", 9},
                  {"TdSetBotTexture","01", 9},
                  {"TdSetFloorTexture","01", 9},
                  {"TdSetCeilTexture","01", 9},
                  {"TdGetWallX2","0",  0},
                  {"TdGetWallY","0",  0},
                  {"TdGetWallY2","0",  0},
                  {"TdGetMidTexture", "0",  1},
                  {"TdGetBotTexture", "0",  1},
                  {"TdGetFloorTexture", "0",  1},
                  {"TdGetCeilTexture", "0",  1},
//1.8
                  {"Triangle", "000000-0+000000",  9},
                  {"MTriangle", "000000-0+000000",  9},

                  {"Load3dObject", "11",  9},
                  {"Draw3dObject", "0002221",  9},
                  {"Set3dObjectPoint", "10000",  9},
                  {"Erase3dObject", "+1",  9},
                  {"Set3dObject", "0222",  9},

                  {"GetSamLength","0",     0},
                  {"GetSamBase",  "0",     0},
                  {"SetSamStart", "00",    9},
                  {"SetSamLength","00",    9},
                  {"ReadHiLoWord", "0",    0},
                  {"WriteHiLoWord","00",   9},
                  {"LoByte", "0",    0},
                  {"HiByte", "0",    0},

                  {"Rectangle", "00-00-00-000",  9},
                  {"MRectangle", "00-00-00-000",  9},

                  {"InLine", "0000-00",  0},

                   {"LLGetTotal","0",     0},
                   {"LLGetNext", "0",     9},
                   {"LLGetPrev", "0",     9},
                   {"LLGetStart","0",     9},
                   {"LLGetEnd",  "0",     9},
                   {"LLInsert",  "00",    9},
                   {"LLDelete",  "0",     9},
                   {"LLClear",   "0+0",     9},
                   {"LLDeleteAll","0",    9},
                   {"LLSwapPrev", "0",    9},
                   {"LLSwapNext", "0",    9},
                   {"LLSetB",     "000",  9},
                   {"LLSetW",     "000",  9},
                   {"LLSetD",     "000",  9},
                   {"LLGetB",     "00",  0},
                   {"LLGetW",     "00",  0},
                   {"LLGetD",     "00",  0},
                   {"LLGetDataLength", "0",  0},
                   {"LLIsNext", "0",     0},
                   {"LLIsPrev", "0",     0},
//1.9
                   {"ConvertFreq","000", 9},
                   {"ModGetNote","00",   0},
                   {"ModGetEffect","00", 0},
                   {"ModGetEffectParam","00",   0},
                   {"ModSetNote","00000000",   9},
                   {"ModGetOctave","00",   0},
                   {"ModGetSample","00",   0},
                   {"ModTranspose","00",   9},
                   {"PokeHiLoWord","00",   9},
                   {"BankLoadMod", "00",   9},

                   {"ModGetPlayPattern", "", 0},
                   {"ModGetPlayRow", "",   0},
                   {"ModGetPlayIndex","",  0},

                   {"Pack",        "0-0",     9},
                   {"UnPack",      "0-0",     9},
                   {"SerialOpen",  "00",      9},
                   {"SerialClose", "",        9},
                   {"SerialSend",  "0",       9},
                   {"SerialReceive","",       0},

                   {"GetCharLen",  "1",       0},
                   {"MenuSet",     "1+1+1+1+1+1+1+1", 9},
                   {"MenuAdd",     "01",      9},
                   {"MenuDraw",    "",        9},
                   {"MenuActivate","0",       0},
                   {"MenuGetOption","",       0},
                   {"MenuGetSelection","",    0},
                   {"MenuSelectPaper","0",    9},
                   {"GetDriveInfo","1",       0},
                   {"TextClip","0",           9},
//1.91
                   {"SetIdle","0",            9},
                   {"TdGetRelative","0",      0},
                   {"SamStatus","0",       0},

//                  {"GetSamChannelPos","0", 0},
//                  {"SaveWav",     "10",    9},
//                  {"SamChannelPlay","00+0+0",9},
//                  {"SetChannelVol","000",9},

//rem tpoly (just auto-render 2 triangles!!)

//Serial Port
//typedef
//add/swap (defines)
//read/input into arrays (defines?)

                  {NULL, NULL ,NULL}
                  };


